library enumeration;

//TODO: when Issue 88 in Dart get resolved delete this file.

/** 
 * Enum base Class
 */
abstract class Enum {
  final int val;
  final String name;
  const Enum(this.name, [this.val]);
  
  static const List<Enum> values = const [];
  
  Enum valueOf(String name) => values.singleWhere((val) => val.name == name);
  
  fromInt(int i) => values.singleWhere((val) => val.val == i);
}